Commit 3de11b8d authored by Daniel Stone's avatar Daniel Stone Committed by Derek Foreman

wayland-egl: Make symbol test fail on failure

The previous rewrite of the wayland-egl ABI checker introduced checks
for removed symbols as well as added symbols, but broke some failure
conditions. Add an explict return-code variable set in failure paths,
rather than chaining or conditions.

If we cannot find the binary or nm, we regard this as an error
condition, rather than test failure.

v2: Don't test if we can execute $NM.
Signed-off-by: Daniel Stone's avatarDaniel Stone <daniels@collabora.com>
Reported-by: Pekka Paalanen's avatarPekka Paalanen <pekka.paalanen@collabora.co.uk>
Fixes: 21b1f22e ("wayland-egl: enhance the symbol test")
Cc: Emil Velikov <emil.velikov@collabora.com>
Reviewed-by: 's avatarEmil Velikov <emil.velikov@collabora.com>
parent 2031bcf5
#!/bin/sh
set -eu
RET=0
LIB=${WAYLAND_EGL_LIB}
if [ ! -f "$LIB" ]; then
echo "The test binary \"$LIB\" does no exist"
exit 1
if ! test -f "$LIB"; then
echo "Test binary \"$LIB\" does not exist"
exit 99
fi
if ! test -n "$NM"; then
echo "nm environment variable not set"
exit 99
fi
AVAIL_FUNCS="$($NM -D --format=bsd --defined-only $LIB | awk '{print $3}')"
......@@ -32,7 +38,11 @@ NEW_ABI=$(echo "$AVAIL_FUNCS" | while read func; do
echo $func
done)
test ! -n "$NEW_ABI" || echo "New ABI detected - If intentional, update the test."; echo "$NEW_ABI"
if test -n "$NEW_ABI"; then
echo "New ABI detected - If intentional, update the test."
echo "$NEW_ABI"
RET=1
fi
REMOVED_ABI=$(echo "$REQ_FUNCS" | while read func; do
echo "$AVAIL_FUNCS" | grep -q "^$func$" && continue
......@@ -40,5 +50,10 @@ REMOVED_ABI=$(echo "$REQ_FUNCS" | while read func; do
echo $func
done)
test ! -n "$REMOVED_ABI" || echo "ABI break detected - Required symbol(s) no longer exported!"; echo "$REMOVED_ABI"
test ! -n "$NEW_ABI" || test ! -n "$REMOVED_ABI"
if test -n "$REMOVED_ABI"; then
echo "ABI break detected - Required symbol(s) no longer exported!"
echo "$REMOVED_ABI"
RET=1
fi
exit $RET
Markdown is supported
0% or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment